import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
import { useEffect, useState } from 'react';
import OptionButton from '../option-button/option-button';
import SearchBox from '../search-box/search-box';
import ReplaceBox from '../replace-box/replace-box';
import ReplaceButton from '../replace-button/replace-button';
import ExpandMoreIcon from '@mui/icons-material/ExpandMore';
import NavigateNextIcon from '@mui/icons-material/NavigateNext';
import { Box, Button, Collapse, FormControl } from '@mui/material';
import { VscCaseSensitive, VscWholeWord, VscRegex, VscPreserveCase, VscReplaceAll, } from 'react-icons/vsc';
import OptionsBar from '../options-bar/options-bar';
const defaultSearchOptions = {
    isCaseMatched: false,
    isWordMatched: false,
    isRegex: false,
};
const defaultReplaceOptions = {
    isCasePreserved: false,
};
export function FindrForm({ onChangeOptions: _onChangeOptions, onChangeTarget, onChangeReplacement, onReplaceAll, target, replacement, options, groups }) {
    const [showReplace, setShowReplace] = useState(false);
    useEffect(() => {
        if (typeof _onChangeOptions === 'function') {
            _onChangeOptions(Object.assign(Object.assign({}, defaultSearchOptions), defaultReplaceOptions));
        }
    }, [_onChangeOptions]);
    const onChangeOptions = (event, newOptions) => {
        if (typeof _onChangeOptions === 'function')
            _onChangeOptions((options) => (Object.assign(Object.assign({}, options), newOptions)));
    };
    return (_jsxs(Box, Object.assign({ sx: {
            display: 'grid',
            gridTemplateColumns: 'auto minmax(0, 1fr)',
            gridAutoFlow: 'column',
            gap: '0.2em',
        } }, { children: [_jsx(FormControl, Object.assign({ margin: 'dense' }, { children: _jsx(Button, Object.assign({ title: 'toggle replace', sx: {
                        height: '100%',
                        p: 0,
                        minWidth: 'auto',
                        color: 'rgba(0, 0, 0, 0.87)',
                    }, variant: 'text', onClick: () => setShowReplace((value) => !value) }, { children: showReplace ? _jsx(ExpandMoreIcon, {}) : _jsx(NavigateNextIcon, {}) })) })), _jsxs(Box, Object.assign({ sx: { display: 'grid', padding: '0em' } }, { children: [_jsx(SearchBox, { defaultValue: target, onChange: typeof onChangeTarget === 'function' ? onChangeTarget : () => null, searchOptions: _jsxs(OptionsBar, Object.assign({ defaultOptions: defaultSearchOptions, onChange: onChangeOptions }, { children: [_jsx(OptionButton, Object.assign({ value: "isCaseMatched", title: "Match Case" }, { children: _jsx(VscCaseSensitive, { size: '1.5em' }) })), _jsx(OptionButton, Object.assign({ value: "isWordMatched", title: "Match Whole Word" }, { children: _jsx(VscWholeWord, { size: '1.5em' }) })), _jsx(OptionButton, Object.assign({ value: "isRegex", title: "Use Regular Expression" }, { children: _jsx(VscRegex, { size: '1.5em' }) }))] })) }), _jsx(Collapse, Object.assign({ in: showReplace }, { children: _jsxs(Box, Object.assign({ sx: {
                                display: 'grid',
                                gap: '0.5em',
                                gridTemplateColumns: 'minmax(0, 1fr) auto',
                            } }, { children: [_jsx(ReplaceBox, { defaultValue: replacement, onChange: typeof onChangeReplacement === 'function'
                                        ? onChangeReplacement
                                        : () => null, replaceOptions: _jsx(OptionsBar, Object.assign({ defaultOptions: defaultReplaceOptions, onChange: onChangeOptions }, { children: _jsx(OptionButton, Object.assign({ value: "isCasePreserved", title: "Preserve case" }, { children: _jsx(VscPreserveCase, { size: '1.5em' }) })) })) }), _jsx(ReplaceButton, Object.assign({ variant: "outlined", onClick: () => {
                                        onReplaceAll({
                                            target,
                                            replacement,
                                            groups,
                                            options,
                                        });
                                    }, title: "Replace All" }, { children: _jsx(VscReplaceAll, { fontSize: "1.3em" }) }))] })) }))] }))] })));
}
export default FindrForm;
