import { jsx as _jsx } from "@emotion/react/jsx-runtime";
import { useMemo } from 'react';
import ResultsTree from '../results-tree/results-tree';
import ResultsTreeItem from '../results-tree-item/results-tree-item';
import SearchResult from '../search-result/search-result';
import { Box, IconButton } from '@mui/material';
import { VscReplace } from 'react-icons/vsc';
function ResultReplaceButton({ onReplace, title, }) {
    return (_jsx(IconButton, Object.assign({ "aria-label": title, title: title, size: "small", onClick: (e) => {
            e.preventDefault();
            e.stopPropagation();
            if (typeof onReplace === 'function')
                onReplace();
        } }, { children: _jsx(VscReplace, { fontSize: "inherit" }) })));
}
export function FindrResults({ sx, target, replacement, options, groups, setGroups, onSetGroupTitle, onSetGroupCaption, onReplaceGroup, onReplaceResult, onSetResultKey, onSetResultTooltip, onClickResult = () => null, onRenderResult = () => null, defaultCollapsed = false, contextLength = 6, }) {
    const groupsEntries = useMemo(() => Object.entries(groups), [groups]);
    return (_jsx(Box, Object.assign({ sx: sx }, { children: !groupsEntries.length ? null : (_jsx(ResultsTree, Object.assign({ defaultExpanded: defaultCollapsed
                ? []
                : groupsEntries.map(([sourceKey]) => `${sourceKey}`) }, { children: groupsEntries.map(([sourceKey, group], groupIndex) => {
                var _a, _b;
                return !((_a = group === null || group === void 0 ? void 0 : group.results) === null || _a === void 0 ? void 0 : _a.length) ? null : (_jsx(ResultsTreeItem, Object.assign({ itemKey: `${sourceKey}`, title: typeof onSetGroupTitle === 'function'
                        ? onSetGroupTitle(group)
                        : sourceKey, onDismiss: (key) => typeof setGroups === 'function' &&
                        setGroups((currentGroups) => {
                            const newGroups = Object.assign({}, currentGroups);
                            delete newGroups[key];
                            return newGroups;
                        }), content: typeof onSetGroupCaption === 'function'
                        ? onSetGroupCaption(group)
                        : '', tooltip: typeof onSetGroupCaption === 'function'
                        ? onSetGroupCaption(group)
                        : undefined, actions: _jsx(ResultReplaceButton, { onReplace: () => onReplaceGroup({
                            target,
                            replacement,
                            group,
                            options,
                        }), title: "Replace group" }) }, { children: (_b = group === null || group === void 0 ? void 0 : group.results) === null || _b === void 0 ? void 0 : _b.map((result, index) => {
                        return (_jsx(ResultsTreeItem, { onClick: () => onClickResult({ result }), onDismiss: () => typeof setGroups === 'function' &&
                                setGroups((currentGroups) => {
                                    var _a;
                                    return (Object.assign(Object.assign({}, currentGroups), { [sourceKey]: Object.assign(Object.assign({}, currentGroups[sourceKey]), { results: (_a = currentGroups[sourceKey]) === null || _a === void 0 ? void 0 : _a.results.filter((_, i) => index !== i) }) }));
                                }), tooltip: typeof onSetResultTooltip === 'function'
                                ? onSetResultTooltip({ result })
                                : null, itemKey: typeof onSetResultKey === 'function'
                                ? onSetResultKey(result)
                                : sourceKey + '/' + index, actions: _jsx(ResultReplaceButton, { onReplace: () => onReplaceResult({
                                    target,
                                    replacement,
                                    result,
                                    options,
                                }), title: "Replace result" }), title: _jsx(SearchResult, { minCtxWords: contextLength, context: result.context, match: result.match, replacement: result.replacement }), onRenderTitle: ({ items }) => onRenderResult({ nodes: items, data: result }) }, `${sourceKey}-${groupIndex}-${index}`));
                    }) }), `${sourceKey}-${groupIndex}`));
            }) }))) })));
}
export default FindrResults;
