"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FindrResults = void 0;
const tslib_1 = require("tslib");
const jsx_runtime_1 = require("@emotion/react/jsx-runtime");
const react_1 = require("react");
const results_tree_1 = tslib_1.__importDefault(require("../results-tree/results-tree"));
const results_tree_item_1 = tslib_1.__importDefault(require("../results-tree-item/results-tree-item"));
const search_result_1 = tslib_1.__importDefault(require("../search-result/search-result"));
const material_1 = require("@mui/material");
const vsc_1 = require("react-icons/vsc");
function ResultReplaceButton({ onReplace, title, }) {
    return ((0, jsx_runtime_1.jsx)(material_1.IconButton, Object.assign({ "aria-label": title, title: title, size: "small", onClick: (e) => {
            e.preventDefault();
            e.stopPropagation();
            if (typeof onReplace === 'function')
                onReplace();
        } }, { children: (0, jsx_runtime_1.jsx)(vsc_1.VscReplace, { fontSize: "inherit" }) })));
}
function FindrResults({ sx, target, replacement, options, groups, setGroups, onSetGroupTitle, onSetGroupCaption, onReplaceGroup, onReplaceResult, onSetResultKey, onSetResultTooltip, onClickResult = () => null, onRenderResult = () => null, defaultCollapsed = false, contextLength = 6, }) {
    const groupsEntries = (0, react_1.useMemo)(() => Object.entries(groups), [groups]);
    return ((0, jsx_runtime_1.jsx)(material_1.Box, Object.assign({ sx: sx }, { children: !groupsEntries.length ? null : ((0, jsx_runtime_1.jsx)(results_tree_1.default, Object.assign({ defaultExpanded: defaultCollapsed
                ? []
                : groupsEntries.map(([sourceKey]) => `${sourceKey}`) }, { children: groupsEntries.map(([sourceKey, group], groupIndex) => {
                var _a, _b;
                return !((_a = group === null || group === void 0 ? void 0 : group.results) === null || _a === void 0 ? void 0 : _a.length) ? null : ((0, jsx_runtime_1.jsx)(results_tree_item_1.default, Object.assign({ itemKey: `${sourceKey}`, title: typeof onSetGroupTitle === 'function'
                        ? onSetGroupTitle(group)
                        : sourceKey, onDismiss: (key) => typeof setGroups === 'function' &&
                        setGroups((currentGroups) => {
                            const newGroups = Object.assign({}, currentGroups);
                            delete newGroups[key];
                            return newGroups;
                        }), content: typeof onSetGroupCaption === 'function'
                        ? onSetGroupCaption(group)
                        : '', tooltip: typeof onSetGroupCaption === 'function'
                        ? onSetGroupCaption(group)
                        : undefined, actions: (0, jsx_runtime_1.jsx)(ResultReplaceButton, { onReplace: () => onReplaceGroup({
                            target,
                            replacement,
                            group,
                            options,
                        }), title: "Replace group" }) }, { children: (_b = group === null || group === void 0 ? void 0 : group.results) === null || _b === void 0 ? void 0 : _b.map((result, index) => {
                        return ((0, jsx_runtime_1.jsx)(results_tree_item_1.default, { onClick: () => onClickResult({ result }), onDismiss: () => typeof setGroups === 'function' &&
                                setGroups((currentGroups) => {
                                    var _a;
                                    return (Object.assign(Object.assign({}, currentGroups), { [sourceKey]: Object.assign(Object.assign({}, currentGroups[sourceKey]), { results: (_a = currentGroups[sourceKey]) === null || _a === void 0 ? void 0 : _a.results.filter((_, i) => index !== i) }) }));
                                }), tooltip: typeof onSetResultTooltip === 'function'
                                ? onSetResultTooltip({ result })
                                : null, itemKey: typeof onSetResultKey === 'function'
                                ? onSetResultKey(result)
                                : sourceKey + '/' + index, actions: (0, jsx_runtime_1.jsx)(ResultReplaceButton, { onReplace: () => onReplaceResult({
                                    target,
                                    replacement,
                                    result,
                                    options,
                                }), title: "Replace result" }), title: (0, jsx_runtime_1.jsx)(search_result_1.default, { minCtxWords: contextLength, context: result.context, match: result.match, replacement: result.replacement }), onRenderTitle: ({ items }) => onRenderResult({ nodes: items, data: result }) }, `${sourceKey}-${groupIndex}-${index}`));
                    }) }), `${sourceKey}-${groupIndex}`));
            }) }))) })));
}
exports.FindrResults = FindrResults;
exports.default = FindrResults;
