/// <reference types="react" />
import { TreeItemProps } from '@mui/lab';
export interface ResultsTreeItemProps extends Omit<TreeItemProps, 'nodeId' | 'title' | 'label' | 'onClick'> {
    tooltip?: React.ReactNode;
    itemKey: string;
    title?: React.ReactNode;
    content?: React.ReactNode;
    onReplace?: (key: string) => void;
    onDismiss?: (key: string) => void;
    onClick?: (e: React.MouseEvent<HTMLLIElement, MouseEvent>, key: string) => void;
    actions?: React.ReactNode;
    nodeId?: string;
    onRenderTitle?: ({ items }: {
        items: React.ReactNode;
    }) => React.ReactNode;
}
export declare function ResultsTreeItem({ itemKey, tooltip, title, content, onRenderTitle, onReplace, onDismiss, onClick, children, actions, ...props }: ResultsTreeItemProps): import("@emotion/react/types/jsx-namespace").EmotionJSX.Element;
export default ResultsTreeItem;
