import { __rest } from "tslib";
import { jsx as _jsx } from "@emotion/react/jsx-runtime";
import * as React from 'react';
import { ToggleButtonGroup } from '@mui/material';
export function OptionsBar(_a) {
    var { defaultOptions, onChange, children } = _a, props = __rest(_a, ["defaultOptions", "onChange", "children"]);
    const defaultValues = React.useMemo(() => Object.keys(defaultOptions).filter((option) => defaultOptions[option]), [defaultOptions]);
    const [values, setValues] = React.useState(defaultValues);
    const onChangeOptions = (event, newOptions) => {
        setValues(newOptions);
        const options = newOptions.reduce((options, keys) => {
            options[keys] = true;
            return options;
        }, Object.assign({}, defaultOptions));
        onChange(event, options);
    };
    return (_jsx(ToggleButtonGroup, Object.assign({ "aria-label": "search options", title: "search options", size: 'small' }, props, { value: values, onChange: onChangeOptions }, { children: children })));
}
export default OptionsBar;
